subroutine NearestGrid( &
  & imax, jmax, x_Lon, y_Lat, TarLon, TarLat, &
  & MinI, MinJ, MinDis &
  & )

  use vtype_module
  use const_module, only : d2r, pradi

  implicit none

  integer , intent(in ) :: imax
  integer , intent(in ) :: jmax
  real(dp), intent(in ) :: x_Lon(0:imax-1)
  real(dp), intent(in ) :: y_Lat(1:jmax  )
  real(dp), intent(in ) :: TarLon
  real(dp), intent(in ) :: TarLat
  integer , intent(out) :: MinI
  integer , intent(out) :: MinJ
  real(dp), intent(out) :: MinDis


  !
  ! Local variables
  !
  real(dp) :: x_SinLon(0:imax-1)
  real(dp) :: x_CosLon(0:imax-1)
  real(dp) :: y_SinLat(1:jmax)
  real(dp) :: y_CosLat(1:jmax)
  real(dp) :: CosDel
  real(dp) :: Dist

  integer  :: i
  integer  :: j


  x_SinLon = sin( x_Lon * d2r )
  x_CosLon = cos( x_Lon * d2r )
  y_SinLat = sin( y_Lat * d2r )
  y_CosLat = cos( y_Lat * d2r )


  MinDis = 1.0d10
  MinI   = 0
  MinJ   = 0

  do j = 1, jmax
    do i = 0, imax-1
      Cosdel = &
        &   y_CosLat( j ) * x_CosLon( i ) * cos( TarLat * d2r ) * cos( TarLon * d2r ) &
        & + y_CosLat( j ) * x_SinLon( i ) * cos( TarLat * d2r ) * sin( TarLon * d2r ) &
        & + y_SinLat( j ) * sin( TarLat * d2r )
      Dist = acos( CosDel ) * pradi * 1.0d-3
      if( MinDis > Dist ) then
        MinDis = Dist
        MinI   = i
        MinJ   = j
      end if
!            write( 6, '(2i,2e)' ) lon( i ), lat( j ), dist
    end do
!         write( 6, * )
  end do
!      write( 6, * ) 'mini, minj, mindis'
!      write( 6, * )  mini, minj, mindis


end subroutine NearestGrid
